declare type GRecaptchaResultToken = string;
export declare type GRecaptchaExecute = (siteKey: string, { action }: {
    action: string;
}) => PromiseLike<GRecaptchaResultToken>;
export declare type RecaptchaWindow = typeof window & {
    grecaptcha: {
        ready: (cb: Function) => void;
        execute: GRecaptchaExecute;
    };
};
export declare type HookEntryParams = {
    siteKey: string;
    lang?: string;
};
export declare type GetRecaptchaToken = (action: string) => Promise<GRecaptchaResultToken>;
export declare type ReadinessStatus = {
    loading: boolean;
    ready: boolean;
    error: Error | null;
};
export declare type ReturnedHookValue = {
    status: ReadinessStatus;
    getRecaptchaToken: GetRecaptchaToken;
};
export {};
