(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-script-hook')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'react-script-hook'], factory) :
  (global = global || self, factory(global.manifest = {}, global.react, global.useScript));
}(this, (function (exports, react, useScript) { 'use strict';

  useScript = useScript && Object.prototype.hasOwnProperty.call(useScript, 'default') ? useScript['default'] : useScript;

  function _newArrowCheck(innerThis, boundThis) {
    if (innerThis !== boundThis) {
      throw new TypeError("Cannot instantiate an arrow function");
    }
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;

    var _s, _e;

    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var _this = undefined;

  var generateScriptSrc = function generateScriptSrc(_ref) {
    _newArrowCheck(this, _this);

    var siteKey = _ref.siteKey,
        lang = _ref.lang;
    var baseSrc = "https://www.google.com/recaptcha/api.js?render=".concat(siteKey);

    if (lang) {
      baseSrc = "".concat(baseSrc, "&hl=").concat(lang);
    }

    return baseSrc;
  }.bind(undefined);

  var _this$1 = undefined;

  var useRecaptcha = function useRecaptcha(_ref) {
    var _this2 = this;

    _newArrowCheck(this, _this$1);

    var siteKey = _ref.siteKey,
        lang = _ref.lang;

    var _useState = react.useState({
      loading: true,
      ready: false,
      error: null
    }),
        _useState2 = _slicedToArray(_useState, 2),
        status = _useState2[0],
        setStatus = _useState2[1];

    var handleLoadScript = function handleLoadScript() {
      var _this3 = this;

      _newArrowCheck(this, _this2);

      window.grecaptcha.ready(function () {
        _newArrowCheck(this, _this3);

        setStatus({
          loading: false,
          ready: true,
          error: null
        });
      }.bind(this));
    }.bind(this);

    var handleErrorScript = function handleErrorScript() {
      _newArrowCheck(this, _this2);

      setStatus({
        loading: false,
        ready: false,
        error: new Error('An error occurred while loading Recaptcha')
      });
    }.bind(this);

    var getRecaptchaToken = function getRecaptchaToken(action) {
      var _this4 = this;

      _newArrowCheck(this, _this2);

      return new Promise(function (resolve, reject) {
        var _this5 = this;

        _newArrowCheck(this, _this4);

        if (!status.ready) {
          reject(Error('Recaptcha script not yet loaded'));
        }

        window.grecaptcha.execute(siteKey, {
          action: action
        }).then(resolve, function (error) {
          _newArrowCheck(this, _this5);

          if (!error) {
            reject(Error('Error while receiving token'));
          }

          reject(error);
        }.bind(this));
      }.bind(this));
    }.bind(this);

    useScript({
      src: generateScriptSrc({
        siteKey: siteKey,
        lang: lang
      }),
      onload: handleLoadScript,
      onerror: handleErrorScript
    });
    return {
      status: status,
      getRecaptchaToken: getRecaptchaToken
    };
  }.bind(undefined);

  exports.default = useRecaptcha;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
